package com.ekexiu.portal.service;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.JpgUtil;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;
import org.jfw.util.exception.JfwBaseException;
import org.jfw.util.io.IoUtil;

import com.ekexiu.portal.dao.ArticleAgreeDao;
import com.ekexiu.portal.dao.ArticleDao;
import com.ekexiu.portal.dao.LeaveWordDao;
import com.ekexiu.portal.dao.OrgDao;
import com.ekexiu.portal.dao.ProfessorDao;
import com.ekexiu.portal.dao.ResearchAreaDao;
import com.ekexiu.portal.dao.ResourceDao;
import com.ekexiu.portal.dao.WatchDao;
import com.ekexiu.portal.po.Article;
import com.ekexiu.portal.po.ArticleAgree;
import com.ekexiu.portal.po.Image;
import com.ekexiu.portal.pojo.FindInfo;

@Path("/article")
public class ArticleService {
	private File tmpPath;
	private File articlePath;
	private String dateFormat = "yyyyMMdd";
	private int artMaxLen=640;
	private static final String JPG = "jpg";
	public static final String MAX_MODIFYTIME = "9";
	@Autowrie
	private ArticleDao articleDao;
	@Autowrie
	private ArticleAgreeDao articleAgreeDao;
	@Autowrie
	private ProfessorDao professorDao;
	@Autowrie
	private ResourceDao resourceDao;
	@Autowrie
	private ImageService imageService;
	@Autowrie
	private ImagesService imagesService;
	@Autowrie
	private ResearchAreaDao researchAreaDao;
	@Autowrie
	private LeaveWordDao leaveWordDao;
	@Autowrie
	private OrgDao orgDao;
	@Autowrie
	private WatchDao watchDao;

	public String getDateFormat() {
		return dateFormat;
	}

	public void setDateFormat(String dateFormat) {
		this.dateFormat = dateFormat;
	}

	public File getTmpPath() {
		return tmpPath;
	}

	public void setTmpPath(File tmpPath) {
		this.tmpPath = tmpPath;
	}

	public File getArticlePath() {
		return articlePath;
	}

	public void setArticlePath(File articlePath) {
		this.articlePath = articlePath;
	}

	public int getArtMaxLen() {
		return artMaxLen;
	}

	public void setArtMaxLen(int artMaxLen) {
		this.artMaxLen = artMaxLen;
	}

	public ArticleDao getArticleDao() {
		return articleDao;
	}

	public void setArticleDao(ArticleDao articleDao) {
		this.articleDao = articleDao;
	}
	
	public ArticleAgreeDao getArticleAgreeDao() {
		return articleAgreeDao;
	}

	public void setArticleAgreeDao(ArticleAgreeDao articleAgreeDao) {
		this.articleAgreeDao = articleAgreeDao;
	}

	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	public ResourceDao getResourceDao() {
		return resourceDao;
	}

	public void setResourceDao(ResourceDao resourceDao) {
		this.resourceDao = resourceDao;
	}

	public ImageService getImageService() {
		return imageService;
	}

	public void setImageService(ImageService imageService) {
		this.imageService = imageService;
	}

	public ImagesService getImagesService() {
		return imagesService;
	}

	public void setImagesService(ImagesService imagesService) {
		this.imagesService = imagesService;
	}

	public ResearchAreaDao getResearchAreaDao() {
		return researchAreaDao;
	}

	public void setResearchAreaDao(ResearchAreaDao researchAreaDao) {
		this.researchAreaDao = researchAreaDao;
	}

	public LeaveWordDao getLeaveWordDao() {
		return leaveWordDao;
	}

	public void setLeaveWordDao(LeaveWordDao leaveWordDao) {
		this.leaveWordDao = leaveWordDao;
	}

	public OrgDao getOrgDao() {
		return orgDao;
	}

	public void setOrgDao(OrgDao orgDao) {
		this.orgDao = orgDao;
	}

	public WatchDao getWatchDao() {
		return watchDao;
	}

	public void setWatchDao(WatchDao watchDao) {
		this.watchDao = watchDao;
	}

	private byte[] resImage(byte[] src, int maxLen) throws IOException {
		ByteArrayInputStream in = new ByteArrayInputStream(src);
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		JpgUtil.scalingZoom(in, out, maxLen);
		out.flush();
		return out.toByteArray();
	}
	
	private byte[] readTmpFile(String fn) throws JfwBaseException {
		File file = new File(this.tmpPath, fn);
		if (!file.exists())
			throw new JfwBaseException(90, "resource image not exists");
		try {
			InputStream in = new FileInputStream(file);
			ByteArrayOutputStream out = new ByteArrayOutputStream();
			IoUtil.copy(in, out, true, true);
			return out.toByteArray();
		} catch (IOException e) {
			throw new JfwBaseException(91, "read temp resource image error", e);
		}
	}
	
	private void saveArtImg(String fn, String id) throws JfwBaseException, IOException{
		byte[] src = this.readTmpFile(fn);
		src = JpgUtil.read(src);
		byte[] shareResImage = this.resImage(src, this.artMaxLen);
		String savePath = this.articlePath + "/" + this.createDate();
		File dateFile = new File(savePath);
		if (!dateFile.exists()) {
			// 创建日期目录
			dateFile.mkdir();
		}
		IoUtil.saveStream(new FileOutputStream(new File(dateFile, id + "." + JPG)), src, true);
		IoUtil.saveStream(new FileOutputStream(new File(dateFile, id + "_s." + JPG)), shareResImage, true);
	}
	
	private String createDate(){
		SimpleDateFormat df = new SimpleDateFormat(this.dateFormat);
		String date = df.format(new Date());
		return date;
	}
	
	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, Article article) 
			throws SQLException, IOException, JfwBaseException{
		String articleId = StringUtil.buildUUID();
		if(article.getArticleImg() != null){
			this.saveArtImg(article.getArticleImg(), articleId);
			article.setArticleImg(this.createDate()+"/"+articleId+"."+JPG);
		}
		article.setArticleId(articleId);
		article.setArticleAgree(0);
		if(article.getProfessorId() != null && article.getOrgId() == null){
			article.setArticleType("1");
		}else if(article.getProfessorId() == null && article.getOrgId() != null){
			article.setArticleType("2");
		}else{
			throw new JfwBaseException(-1, "错误参数：文章发布者ID");
		}
		this.articleDao.insert(con, article);
		return articleId;
	}
	
	@Post
	@Path("/updateArt")
	public void update(@JdbcConn(true) Connection con, Article article) 
			throws SQLException, JfwBaseException, IOException{
		if(article.getArticleImg() != null){
			this.saveArtImg(article.getArticleImg(), article.getArticleId());
			article.setArticleImg(this.createDate()+"/"+article.getArticleId()+"."+JPG);
		}
		this.articleDao.update(con, article);
	}
	
	@Post
	@Path("/agree")
	public void agree(@JdbcConn(true) Connection con,String operateId,String articleId)throws SQLException{
		if(this.articleDao.incAgree(con, articleId) > 0){
			ArticleAgree articleAgree = new ArticleAgree();
			articleAgree.setOperateId(operateId);
			articleAgree.setArticleId(articleId);
			this.articleAgreeDao.insert(con, articleAgree);
		}
	}
	
	@Post
	@Path("/unAgree")
	public void unAgree(@JdbcConn(true) Connection con,String operateId,String articleId)throws SQLException{
		if(this.articleDao.decAgree(con, articleId) > 0){
			this.articleAgreeDao.deleteAgree(con, operateId, articleId);
		}
	}
	
	@Get
	@Path("/isAgree")
	public ArticleAgree queryAgree(@JdbcConn Connection con,String operateId,String articleId)throws SQLException{
		return this.articleAgreeDao.queryOne(con, operateId, articleId);
	}
	
	@Get
	@Path("/agreeList")
	public List<ArticleAgree> queryAgreeList(@JdbcConn Connection con,String articleId)throws SQLException{
		return this.articleAgreeDao.query(con, articleId);
	}
	
	@Get
	@Path("/qaPro")
	public List<Article> queryPro(@JdbcConn Connection con, String professorId) throws SQLException{
		return this.articleDao.queryPro(con, professorId);
	}
	
	@Get
	@Path("/qaOrg")
	public List<Article> queryOrg(@JdbcConn Connection con,String orgId)throws SQLException{
		return this.articleDao.queryOrg(con, orgId);
	}
	
	@Get
	@Path("/qlOrg")
	public List<Article> queryLimitOrg(@JdbcConn Connection con,String orgId,@DefaultValue("com.ekexiu.portal.service.ArticleService.MAX_MODIFYTIME") String modifyTime,@DefaultValue("20") int rows)throws SQLException{
		return this.articleDao.queryLimit(con, orgId, modifyTime, rows);
	}
	
	@Get
	@Path("/query")
	public Article queryOne(@JdbcConn Connection con, String articleId) throws SQLException{
		return this.articleDao.queryOne(con, articleId);
	}
	
	@Get
	@Path("/pqFind")
	public PageQueryResult<FindInfo> queryPage(@JdbcConn Connection con,@DefaultValue("10") int pageSize,@DefaultValue("1") int pageNo)throws SQLException{
		PageQueryResult<FindInfo> queryResult = this.articleDao.queryPage(con, pageSize, pageNo);
		List<FindInfo> findInfos = queryResult.getData();
		for (FindInfo findInfo : findInfos) {
			if("3".equals(findInfo.getType())){
				List<Image> images = this.imagesService.queryRes(con, findInfo.getId());
				if(images.size() > 0){
					findInfo.setImage(findInfo.getId()+".jpg");
				}
			}
		}
		queryResult.setData(findInfos);
		return queryResult;
	}
	
	@Post
	@Path("/delete")
	public void delete(@JdbcConn(true) Connection con, String articleId) throws SQLException{
		this.articleDao.delete(con, articleId);
		this.leaveWordDao.deleteArticle(con, articleId);
		this.articleAgreeDao.delete(con, articleId);
		this.watchDao.deleteWatch(con, articleId);
	}

}
